Subject: bug#49558: fill paragraph in texinfo-mode fails with @

From: Eli Zaretskii <[email-masked]>
Date: Wed, 14 Jul 2021 16:22:31 +0300

> From: Lars Ingebrigtsen <[email-masked]>
> Cc: [email-masked],  [email-masked],  [email-masked]
> Date: Wed, 14 Jul 2021 15:15:04 +0200
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >> > @node Foo Bar Baz Quux Very Long Node Name
> >> >
> >> > @subsection This is a very long subsection name
> >> >
> >> > @cindex a very long index entry that could wrap
> >> >
> >> > @defun my-func with many different arguments that could wrap
> >> >
> >> > @end multitable
> >> 
> >> The problem is that all of that is currently a single paragraph -- and I
> >> don't think that's something we want?  (Try saying
> >> `M-: (forward-paragraph)' at the start.)
> >
> > What exactly do we not want in the result of forward-paragraph in
> > these cases?  I'm probably missing something.
> 
> I think the example text you pasted should be five paragraphs, not one.

That's because you think about it as plain text.  It isn't.
Basically, lines that start with @foo are directives, not text.

It could be somewhat surprising, because it otherwise looks very much
like plain text, but without those definitions of paragraph-start and
paragraph-separate, things would be much worse.  E.g., copy this to a
text-mode buffer, then type M-q:

@itemize @bullet
@item
If the text consists of a special glyph, the glyph can specify a
particular face.  @xref{Glyphs}.